"use strict";
const core = require("@babel/core");
const helperPluginUtils = require("@babel/helper-plugin-utils");
const THREE = require("three");
function _interopNamespaceDefault(e) {
  const n = Object.create(null, { [Symbol.toStringTag]: { value: "Module" } });
  if (e) {
    for (const k in e) {
      if (k !== "default") {
        const d = Object.getOwnPropertyDescriptor(e, k);
        Object.defineProperty(n, k, d.get ? d : {
          enumerable: true,
          get: () => e[k]
        });
      }
    }
  }
  n.default = e;
  return Object.freeze(n);
}
const THREE__namespace = /* @__PURE__ */ _interopNamespaceDefault(THREE);
const imports = /* @__PURE__ */ new Map();
let lastImport = null;
const index = helperPluginUtils.declare((api) => {
  api.assertVersion(7);
  return {
    manipulateOptions(_, options) {
      options.plugins.push("jsx");
    },
    post() {
      imports.clear();
      lastImport = null;
    },
    visitor: {
      CallExpression(path) {
        if (core.types.isIdentifier(path.node.callee) && path.node.callee.name === "extend" && core.types.isIdentifier(path.node.arguments[0]) && path.node.arguments[0].name === "THREE") {
          path.remove();
        }
      },
      ImportDeclaration(importPath) {
        lastImport = importPath;
      },
      JSXOpeningElement(path) {
        var _a;
        const { name } = path.node;
        if (core.types.isJSXNamespacedName(name))
          return;
        let type = "property" in name ? name.property.name : name.name;
        const declaration = (_a = path.scope.getBinding(type)) == null ? void 0 : _a.path.node;
        if (core.types.isVariableDeclarator(declaration)) {
          if (core.types.isStringLiteral(declaration.init)) {
            type = declaration.init.value;
          } else if (core.types.isTemplateLiteral(declaration.init)) {
            type = declaration.init.quasis.map((n) => n.value.cooked).join("\\w*");
          } else if (core.types.isBinaryExpression(declaration.init) || core.types.isAssignmentExpression(declaration.init)) {
            type = [declaration.init.left, declaration.init.right].map((o) => core.types.isStringLiteral(o) ? o.value : "\\w*").join("");
          } else if (core.types.isConditionalExpression(declaration.init)) {
            type = [declaration.init.consequent, declaration.init.alternate].map((o) => core.types.isStringLiteral(o) ? o.value : "\\w*").join("|");
          } else {
            type = "\\w+";
          }
        }
        const pattern = new RegExp(`^${type}$`);
        for (const className in THREE__namespace) {
          const type2 = className.replace(/^[A-Z]/, (c) => c.toLowerCase());
          if (!imports.has(className) && pattern.test(type2)) {
            const local = path.scope.generateUidIdentifier(className);
            imports.set(className, core.types.importSpecifier(local, core.types.identifier(className)));
          }
        }
      },
      Program: {
        exit(path) {
          if (!imports.size)
            return;
          const THREEImports = core.types.importDeclaration([...imports.values()], core.types.stringLiteral("three"));
          const extendImport = core.types.importSpecifier(path.scope.generateUidIdentifier("extend"), core.types.identifier("extend"));
          const extendCall = core.types.expressionStatement(
            core.types.callExpression(extendImport.local, [
              core.types.objectExpression(
                THREEImports.specifiers.map(
                  (importSpecifier) => core.types.objectProperty(importSpecifier.imported, importSpecifier.local, false, true)
                )
              )
            ])
          );
          const R3FExports = core.types.importDeclaration([extendImport], core.types.stringLiteral("@react-three/fiber"));
          for (const node of [extendCall, R3FExports, THREEImports]) {
            if (lastImport)
              lastImport.insertAfter(node);
            else
              path.unshiftContainer("body", node);
          }
        }
      }
    }
  };
});
module.exports = index;
//# sourceMappingURL=index.js.map
